package org.wffm.digicomi;

/*
 * ImagePane.java - Short Description
 * Copyright (C) 2000-2001 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.util.ResourceBundle;

import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.ImageIcon;

import org.wffm.gassan.view.effect.*;
import org.wffm.gassan.view.image.ImageCreater;
import org.wffm.gassan.view.image.ImageCreaterException;

import org.wffm.gassan.model.scenario.GElement;
import org.wffm.gassan.model.scenario.GElementList;

import org.wffm.gsmlviewer.pane.*;

/**
  * C[WNX(fWR~p)
  * @version 1.0.0, 2001/01/30
  * @author Yosuke Sato
  */
public class D_ImagePane extends ImagePane {

	//
	//  [Jϐ
	//
	//=========================================================================
	private ResourceBundle rb = null;
	private final static String resourceName = "resources/Digicomi";

	//ȉg\pϐ
	GElement zoom = null;
	private JMenuItem menuItem_Zoom = null;
	private JPopupMenu popupMenu = null;
	private MouseEvent mouseEvent = null;
	private MouseEventHandler mouseEventHandler = new MouseEventHandler();
	private ActionEventHandler actionEventHandler = new ActionEventHandler();
	private ImageIcon zoomIcon = new ImageIcon("resources/digicomi/zoom.gif");
	
	//ȉ}[J[\pϐ	
	private boolean state_marker = false;
	private Image drawImage_bak = null;
	private javax.swing.ImageIcon markerIcon = new javax.swing.ImageIcon("resources/digicomi/marker.gif");

	//ȉ؂؂\pϐ
	private Image previousLeftImage = null;
	private Image previousRightImage = null;
	private Image afterLeftImage = null;
	private Image afterRightImage = null;
	private boolean rightOpen = true;
	private boolean reverse = false;
class MouseEventHandler implements MouseListener {
	public void mouseClicked(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {
		if (e.getSource() == D_ImagePane.this){
			mouseEvent = e;
			showPopup(e);
		}
	}
}

class ActionEventHandler implements ActionListener {
	public void actionPerformed(java.awt.event.ActionEvent e) {
		if (e.getSource() == D_ImagePane.this.getJMenuItem_Zoom()){
			pushedZoomMenu();
		}
	};
}
/**
 * RXgN^
 */
public D_ImagePane() {
	super();
}
private BufferedImage createImage(GElement imagelist){
	previousLeftImage = afterLeftImage;
	previousRightImage = afterRightImage;
	afterLeftImage = null;
	afterRightImage = null;
	
	BufferedImage ret = new BufferedImage((int)getDefaultSize().getWidth(),(int)getDefaultSize().getHeight(),BufferedImage.TYPE_INT_RGB);

	if(imagelist != null){
		Graphics g = ret.createGraphics();
		
		GElementList list = imagelist.getChildElements();
		list.first();
		
		int i = 0;	
		for(GElement element = list.item(); element != null; list.next(),element = list.item()){
			ImageCreater creater = null;

			try{
				if(element.getName().equals("image")){
					creater = ImageCreaterFactory.createImageLoader(element);
				}
				else if(element.getName().equals("composer")){
					creater = ImageCreaterFactory.createComposer(element,this);
				}
				else if(element.getName().equals("filter")){
					creater = ImageCreaterFactory.createFilter(element);
				}
			}catch(ImageCreaterException e){
				System.err.println("Can not operate : " + element.getName() );
				creater = null;
			}
			
			if(creater != null){
				try{
					Image image = creater.getImage();
					if(i == 0){
						g.drawImage(image,0,0,this);
						afterLeftImage = image;
					}
					else if( i == 1){
						g.drawImage(image,(int)(getDefaultSize().getWidth() / 2),0,this);
						afterRightImage = image;
						g.setColor(Color.gray);
						g.drawLine((int)(getDefaultSize().getWidth() / 2),0,(int)(getDefaultSize().getWidth() / 2),(int)(getDefaultSize().getHeight()));
					}
					i++;
				}catch(ImageCreaterException e){
					System.err.println("Can not create image.");
				}
			}
		}
	}

	return ret;
}
private JMenuItem getJMenuItem_Zoom() {
	if (menuItem_Zoom == null) {
		menuItem_Zoom = new JMenuItem();
		menuItem_Zoom.setName("JMenuItem_Zoom");
		menuItem_Zoom.setText( rb.getString("menuitem.zoom") );
		menuItem_Zoom.setIcon(zoomIcon);
	}
	return menuItem_Zoom;
}
private JPopupMenu getJPopupMenu() {
	if (popupMenu == null) {
		popupMenu = new JPopupMenu();
		popupMenu.setName("JPopupMenu");
		popupMenu.add(getJMenuItem_Zoom());
	}
	return popupMenu;
}
/**
  * 
  */
public void init(Dimension size){
	super.init(size);
	
	rb = ResourceBundle.getBundle(resourceName);
	this.addMouseListener(mouseEventHandler);
	getJMenuItem_Zoom().addActionListener(actionEventHandler);
}
protected void initImage(){
	previousLeftImage = null;
	previousRightImage = null;
	afterLeftImage = null;
	afterRightImage = null;
}
private void pushedZoomMenu(){
	ImageDialog imageDialog = new ImageDialog();

	//\ʒuvZ
	int x = mouseEvent.getX() - this.getX();
	int y = mouseEvent.getY() - this.getY();

	imageDialog.setTitle( rb.getString("imagedialog.title") );
	imageDialog.show(zoom,getDrawImage(),x,y);
}
protected void run_image(){

	BufferedImage afterImage = createImage(getImageList());
	
	if(getStateEffect()){
		ExchangeEffect effect;

		//effectw肪݂ꍇɏ
		GElementList list = getImageList().getChildElements();
		list.first();
		list.search("effect");
		GElement item = list.item();
		effect = createEffect(item);
		
		if(effect == null){	
			if(previousLeftImage == null ||	previousRightImage == null || afterLeftImage == null || afterRightImage == null){
				//OɌJy[Wi<image>^OP̏ꍇ)
				effect = new Patapata_Height();
			}
			else{
				if(reverse){
					rightOpen = !rightOpen;
				}
				
				if(rightOpen){
					effect = new D_PageEffect();
					((D_PageEffect)effect).setAfterRightImage(afterRightImage);
					((D_PageEffect)effect).setPreviousLeftImage(previousLeftImage);
				}else{
					effect = new D_PageEffect_R();
					((D_PageEffect_R)effect).setAfterLeftImage(afterLeftImage);
					((D_PageEffect_R)effect).setPreviousRightImage(previousRightImage);
				}

				if(reverse){
					rightOpen = !rightOpen;
				}
			}
		}
				
		try{
			effect.setImageSize(getDefaultSize());
			effect.setComponent(this);
			BufferedImage beforeImage = createBufferedImage(getDrawImage());
			effect.setBeforeImage(beforeImage);
			effect.setAfterImage(afterImage);
			
			effect.init();
			effect.run();
			
			Graphics g = getGraphics();
			g.drawImage(afterImage,0,0,this);
			setDrawImage(afterImage);
		}catch(Exception e){
			setDrawImage(afterImage);
		}
	}
	else{
		setDrawImage(afterImage);
	}
	reverse = false;
}
/**
  * C[WXgݒ
  * @param	imageList	C[WXg
  */
public void setImagelist(GElement imagelist){
	GElementList list = imagelist.getChildElements();
	list.first();
	list.search("zoom");
	zoom = list.item();
	
	super.setImagelist(imagelist);
}
/**
  * }[J[ݒ
  * @param	marker	}[J[
  */
public void setMarker(GElement marker){
	String command = marker.getAttributeValue("command");
	if(command != null){
		
		if(!state_marker){
			drawImage_bak = getDrawImage();
		}
		
		if(command.equals("on")){
			state_marker = true;
			Point point = new Point(0,0);
			String x = marker.getAttributeValue("x");
			String y = marker.getAttributeValue("x");
			if(x != null && y != null){
				try{
					point = new Point(Integer.parseInt(x),Integer.parseInt(y));
				}catch(NumberFormatException e){
					System.err.println("Marker Point Error...");
				}
			}
				
			BufferedImage buffer = createBufferedImage(drawImage_bak);
			java.awt.Graphics g = buffer.getGraphics();
			g.drawImage(markerIcon.getImage(),(int)point.getX(),(int)point.getY(),this);
			setDrawImage(buffer);
		}
		else if(command.equals("off")){
			state_marker = false;
			setDrawImage(drawImage_bak);
		}
	}
}
protected void setReverse(boolean reverse){
	this.reverse = reverse;
}
protected void setRightOpen(boolean rightOpen){
	this.rightOpen = rightOpen;
}
private void showPopup(MouseEvent e){
	if(e.isPopupTrigger()){
		getJPopupMenu().show(e.getComponent(),e.getX(),e.getY());
	}
}
}
