package org.wffm.digicomi;

/*
 * D_TextPane.java - Short Description
 * Copyright (C) 2000-2001 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.util.Vector;

import org.wffm.gassan.model.scenario.*;

import org.wffm.gsmlviewer.pane.*;

/**
  * TextLabelNX(fWR~p)
  * @version 1.0.0, 2001/01/30
  * @author Yosuke Sato
  */
public class D_TextPane extends TextPane {
	private int fontSize = 0;
/**
 * D_TextPane RXgN^[ERgB
 */
public D_TextPane() {
	super();
}
/**
  * \ĂeLXgSď
  */
public synchronized void clear() {
	for(int i = 0; i < getLabels().size();i++){
		TextLabel label = (TextLabel)getLabels().elementAt(i);
		label.setFontSize(getFontSize());
	}
	super.clear();
}
/**
  * ͂ݒ
  * @param	text	
  */
public synchronized void setText(GElement text){
	String s = text.getAttributeValue("size");
	if(s != null){
		try{
			fontSize = Integer.parseInt(s);
		}catch(NumberFormatException e){
			fontSize = getFontSize();
			System.err.println("Font Size Error...");
		}
	}
	else{
		fontSize = getFontSize();
	}
	
	super.setText(text);
}
protected Vector textCutter(String text){
	Vector ret = new Vector();

	int tmp = getFontSize();
	
	setFontSize(fontSize);
	ret = super.textCutter(text);
	setFontSize(tmp);

	for(int i = getPaintedLabelCounter(); i <= getLine().size();i++){
		TextLabel label;
		if(i < getLabels().size()){
			label = (TextLabel)getLabels().elementAt(i);
		}
		else{
			label = (TextLabel)getLabels().elementAt(i - getLabels().size());
		}
		
		label.setFontSize(fontSize);
	}
	return ret;
}
}
