package org.wffm.gassan.sample;

/*
 * SamplePlugin.java - Short Description
 * Copyright (C) 1999 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.net.URL;
import java.net.MalformedURLException;
import java.io.File;
import java.applet.AudioClip;
import java.applet.Applet;
import java.awt.Color;
import java.awt.Image;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Dimension;
import java.awt.event.MouseListener;
import java.awt.image.BufferedImage;
import java.awt.font.TextLayout;
import java.awt.font.FontRenderContext;
import javax.swing.ImageIcon;
import java.util.Vector;

import org.wffm.gassan.view.plugin.GPlugin;
import org.wffm.gassan.model.scenario.GElement;

/**
  * TvvOCNX
  * @version 1.1.0, 2000/12/26
  * @author Yosuke Sato
  */
public class SamplePlugin extends GPlugin implements Runnable,MouseListener{
	//
	//  [Jϐ
	//
	//=========================================================================
	private Thread kick = null;
	
	private Image offImage = null;
	private Image bkImage = null;
	private AudioClip audioClip = null;
	private String[] message = {"fRJv"," ",
								"͍̌RV[Y쐬l"," ",
								"gRfQ̔W^ł͂Ȃ"," ",
								"ꂩĐ݌v邱ƂOƂ"," ",
								"RJvł"," ",
								" "," ",
								"fR"," ",
								"ViItH[}bgɂwlk̗p"," ",
								"lubA[LeN`̗p"," ",
								"t[[N"," ",
								"egvOC@\"," ",
								"ɂ荂g̎ɐĂD"," ",
								" "," ",
								"ꂾ̑@\ł̂"," ",
								"щΎRlko[̑Ȃ鏕"," ",
								"̎łD"," ",
								" "," ",
								"fRJv"," ",
								"щΎR@m"};

	private Vector lines = new Vector();
	private int fontSize = 0;

	private final String audioFileName = "resources/plugin/sample.mid";
	private final double fontRatio = 21.4;	//lp

	//\sǗCi[NX
	public class Line{
		Font font = null;
		String text = null;
		int x = 0;
		int y = 0;
		int color = 0;
	}
	/**
	  * RXgN^
	  */
	public SamplePlugin(){
		URL resourceURL = null;
		File audioFile = new java.io.File( audioFileName );
		try {
			resourceURL = audioFile.toURL();
		} catch ( MalformedURLException ex ) {
			resourceURL = null;
		}
		if(resourceURL != null)	audioClip = Applet.newAudioClip(resourceURL);
		setBackground(Color.black);
		this.addMouseListener(this);
	}
	private Image createBackImage(){
		Dimension size = getSize();
		Image buff = createImage((int)size.getWidth(),(int)size.getHeight());
		Graphics2D g2 = (Graphics2D)buff.getGraphics();
		g2.setColor(Color.black);
		g2.fillRect(0,0,(int)size.getWidth(),(int)size.getHeight());		
		return buff;
	}
	private void drawLine(Graphics g,Line line){
		Dimension size = getSize();
		int addColor = 255 / ((((int)size.getHeight()) / 2) / 5);
		if(line.y < (int)size.getHeight()){
			line.color = line.color + addColor;
			if(line.color > 255)	line.color = 255;
		}
		g.setColor(new Color(line.color,line.color,line.color));
		g.setFont(line.font);
		g.drawString(line.text,line.x,line.y);
		line.y = line.y - 5;
	}
	/**
	  * f[^擾
	  * @return	GElement	f[^̖؍\(GElementNX)
	  */
	public GElement getDataOperation(){
		return null;
	}
public void init(){
	start();
}
	private void lineInitialize(Graphics2D g2){
		
		//Line
		Font font = new Font("sansserif", Font.PLAIN,fontSize);
		FontRenderContext frc = g2.getFontRenderContext();
		
		Dimension size = getSize();
		int x = (int)(size.getWidth() / 2);
		int y = (int)size.getHeight() + fontSize;

		for(int i = 0;i < message.length;i++){
			String text = message[i];
			TextLayout tl = new TextLayout(text,font,frc);
			int fontWidth = (int)tl.getVisibleAdvance();
			Line line = new Line();
			line.font = font;
			line.text = text;
			line.y = y;
			line.x = x - (fontWidth / 2);
			lines.addElement(line);
			y = y + font.getSize();
		}
	}
	public void mouseClicked(java.awt.event.MouseEvent e) {}
	public void mouseEntered(java.awt.event.MouseEvent e) {}
	public void mouseExited(java.awt.event.MouseEvent e) {}
public void mousePressed(java.awt.event.MouseEvent e) {
	stop();
	
	//vOCI
	if( getStage() != null){
		getStage().reaction();
	}
}
	public void mouseReleased(java.awt.event.MouseEvent e) {}
	public void paint(Graphics g){
		if(offImage != null){
			g.drawImage(offImage,0,0,this);
		}
	}
public void run(){
	audioClip.loop();
	lineInitialize((Graphics2D)getGraphics());
	bkImage = createBackImage();
	offImage = bkImage;
	repaint();
	Dimension size = getSize();
	Thread thisThread = Thread.currentThread();
	
	while(true){
		if(kick != thisThread){
			return;
		}
		Image buff = createImage((int)size.getWidth(),(int)size.getHeight());
		Graphics2D g2= (Graphics2D)buff.getGraphics();
		g2.drawImage(bkImage,0,0,this);
		Line last = null;
		for(int j = 0;j < lines.size();j++){
			Line line = (Line)lines.elementAt(j);
			drawLine(g2,line);
			last = line;
		}
		if(last != null && last.y < -fontSize)	break;
		offImage = buff;
		repaint();
		timer(100);
	}
	audioClip.stop();
	
	if(kick != thisThread){
		return;
	}
	
	//vOCI
	if( getStage() != null){
		getStage().reaction();
	}
}
	public void setSize(int width,int height){
		super.setSize(width,height);
		//tHgTCYvZ
		fontSize = (int)(width / fontRatio);
	}
	public void setSize(Dimension size){
		super.setSize(size);
		//tHgTCYvZ
		int width = (int)size.getWidth();
		fontSize = (int)(width / fontRatio);
	}
/**
  * vOCJn
  */
public void start(){
	kick = new Thread(this);
	kick.start();
}
/**
  * vOC~
  */
public void stop(){
	audioClip.stop();
	if(kick != null){
		//kick.stop();
		kick = null;
	}
}
}
