package org.wffm.gassan.model;

/*
 * App.java - Short Description
 * Copyright (C) 2000 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.net.URL;
import java.net.MalformedURLException;
import java.io.File;

import org.wffm.gassan.model.io.*;
import org.wffm.gassan.model.translator.GPDtoGSML;
import org.wffm.gassan.model.scenario.GElement;

/**
  * ConsoleViewerp`[NX
  * @version 1.0.1, 2000/10/20
  * @author Yosuke Sato
  */
public class App {
/**
 * RXgN^
 */
public App() {
	super();
}
/**
  * 
  * @return	
  */
public static GElement createEnvironment(URL envURL){
	GElement ret = null;
			
	//t@C^Cv
	int separatorIndex = envURL.getFile().lastIndexOf( "." );
	String fileType = envURL.getFile().substring( separatorIndex + 1, envURL.getFile().length() );

	if( fileType.equals("geml") ){
		ret = createGEML(envURL);
	}
	else if( fileType.equals("gpd") || fileType.equals("gad") ){
		ret = GPDtoGSML.createEnvironment(envURL);
	}
	
	return ret;
}
private static GElement createGEML(URL url){
	GElement ret = null;
	
	//GElement
	GElement element = null;
	try{
		element = GElement.create(url);

		//o[WRg[
		if(element.getAttributeValue("version").equals("1.0")){

			//͑GEML1.0̏ꍇ
			GEMLThrowInputStream gtis = new GEMLThrowInputStream( element );
			GEMLConverter converter = new GEML1_0to1_1( gtis );
			ret = converter.read();
		}
		else{
			//ȊO
			ret = element;
		}
	}catch(org.xml.sax.SAXException se){
		System.err.println("GEML Parser Error...");
		ret = null;
	}
	catch(java.io.IOException ie){
		System.err.println("GEML IO Error...");
		ret = null;
	}
	catch(GEMLIOException e){
		System.err.println("GEML Stream Error...");
		ret = null;
	}
	catch(Exception e){
		System.err.println("GEML Read Error...");
		ret = null;
	}
	
	return ret;
}
/**
 * main֐(u[gV[PX)
 * @param	args	R}hC(1:ViIt@C)
 * N) java -classpath .;extensions/;lib/xerces.jar jp.gr.java_conf.wffm.gassan.model.App testscenario/1_1/sample/index.geml
 */
public static void main(String[] args) {

	try{
		String envFileName = "scenario/testscenario.geml";
		URL envURL = null;

		envFileName = args[0];
	
		File envFile = new File( envFileName );
		try {
			envURL = envFile.toURL();
		} catch ( MalformedURLException ex ) {
				envURL = null;
		}

		GElement env = createEnvironment(envURL);
	
		//viewydirector
		ConsoleViewer view = new ConsoleViewer();
		
		GDirector director = new GDirectorImpl();
		director.init(env);
		
		//Stage -> Directorւ̊֘AZbg
		view.setDirector(director);

		//Director -> Stageւ̊֘AZbg
		director.setStage(view);

		view.construct(env);
	}
	catch( ArrayIndexOutOfBoundsException e){
		System.err.println("Usage: java App filename");
	}
}
}
