package org.wffm.gassan.model.scenario;

/*
 * GElementSerializer.java - Short Description
 * Copyright (C) 2000 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.io.OutputStream;
import java.io.Writer;
import java.io.IOException;

import org.apache.xml.serialize.XMLSerializer;
import org.apache.xml.serialize.DOMSerializer;
import org.apache.xml.serialize.OutputFormat;

/**
  * \vfۑNX
  * @version 1.0.0, 2000/11/18
  * @author Yosuke Sato
  */
public class GElementSerializer {
/**
  * eXgp\bh
  */
public static void main( String argv[] ){
	//GElementSerializereXgp\bh
	try{
		java.io.File file = new java.io.File(argv[0]);
		GElement element = GElement.create(file.toURL());

		GElementSerializer.serialize(System.out,element,"Shift_JIS");
	}
	catch( ArrayIndexOutOfBoundsException e){
		System.err.println("Usage: java GElement filename");
	}
	catch( IOException e ){
		System.err.println(argv[0] + "not Found");
	}
	catch( Exception e){
		System.err.println("Error....");
		System.err.println(e);
	}
	/*--- Xerces ݃Tv
	Document doc = new DocumentImpl();
	Element root=doc.createElement("JINBUTULIST");
	addNode(doc,root,"҂",32);
	addNode(doc,root,"΂҂",31);
	addNode(doc,root,"܂Ƃ΂",40);
	doc.appendChild(root);
	
	OutputFormat format=new OutputFormat(doc);
	format.setDoctype(null,"test.dtd");
	format.setEncoding("Shift_JIS");

	XMLSerializer serializer = new XMLSerializer(System.out,format);
	serializer.asDOMSerializer().serialize(doc.getDocumentElement());
	--- */
}
/**
  * VACY
  * @param	out		OutputStream
  * @param	format	OutputFormat
  * @param	element	ۑΏۂ̍\vf
  */
public static void serialize(OutputStream out,OutputFormat format,GElement element){
	try{
		DOMSerializer serializer = new XMLSerializer(out,format).asDOMSerializer();
		serializer.serialize(element.getCurrentDocument());
	}catch(IOException e){
		System.err.println("Can not DOM serialize");
	}
}
/**
  * VACY
  * @param	out		OutputStream
  * @param	element	ۑΏۂ̍\vf
  * @param	encode	GR[h
  */
public static void serialize(OutputStream out,GElement element,String encoding){
	OutputFormat format = new OutputFormat(element.getCurrentDocument(),encoding,false);
	format.setPreserveSpace(true);
	format.setStandalone(true);
	format.setOmitXMLDeclaration(true);
	//format.setDoctype(null,dtd);

	serialize(out,format,element);
}
/**
  * VACY
  * @param	writer	Writer
  * @param	format	OutputFormat
  * @param	element	ۑΏۂ̍\vf
  */
public static void serialize(Writer writer,OutputFormat format,GElement element){
	try{
		DOMSerializer serializer = new XMLSerializer(writer,format).asDOMSerializer();
		serializer.serialize(element.getCurrentDocument());
	}catch(IOException e){
		System.err.println("Can not DOM serialize");
	}
}
/**
  * VACY
  * @param	writer	Writer
  * @param	element	ۑΏۂ̍\vf
  * @param	encode	GR[h
  */
public static void serialize(Writer writer,GElement element,String encoding,String dtd){
	OutputFormat format = new OutputFormat(element.getCurrentDocument(),encoding,false);
	format.setPreserveSpace(true);
	format.setStandalone(true);
	format.setOmitXMLDeclaration(true);
	//format.setDoctype(null,dtd);

	serialize(writer,format,element);
}
}
