package org.wffm.gassan.model.translator;

/*
 * GPDtoGSML.java - Short Description
 * Copyright (C) 1999-2000 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.net.URL;
import java.net.MalformedURLException;
import java.util.StringTokenizer;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

import org.wffm.gassan.model.scenario.*;
import jp.gr.java_conf.wffm.gassan.data.*;


/**
  * GPDtoGSML
  * @version 1.2.0, 2000/12/29
  * @author Yosuke Sato
  */
public class GPDtoGSML{
	public final static String documentClassName = "org.apache.xerces.dom.DocumentImpl";
/**
  * GEML쐬
  * @param	gpdURL	GPDt@CURL
  * @return	GEML
  */
public static GElement createEnvironment(URL gpdURL){
	GElement result = null;
		
	try{
		//DocumentIuWFNg̐
		Document doc = (Document)Class.forName( documentClassName ).newInstance();
		Element root = doc.createElement("geml");
		root.setAttribute("version","1.1");
		
		Element item1,item2,item3;
			
		//ViI
		String URLString = gpdURL.toString();
		int separatorIndex = URLString.lastIndexOf( "." );
		int fileSeparatorIndex = URLString.lastIndexOf( "/" );
		String scenarioName = URLString.substring( fileSeparatorIndex + 1, separatorIndex );
		String scenarioFile = URLString.substring(fileSeparatorIndex,URLString.length());
		
		item1 = doc.createElement("scenario");
		item1.setAttribute("name",scenarioName);
		item1.setAttribute("gsmlFile",scenarioFile);
			
		//^Cg
		item2 = doc.createElement("title");
		item2.appendChild(doc.createTextNode(scenarioName+"(GPDViI`)"));
		item1.appendChild(item2);
			
		//ҏ񏈗
		item2 = doc.createElement("creator");
		item2.setAttribute("name","unknown");
		item2.setAttribute("URL","unknown");
		item2.setAttribute("E-mail","unknown");
		item2.setAttribute("date","unknown");
		item1.appendChild(item2);

		root.appendChild(item1);

		//ʏ񏈗
		item1 = doc.createElement("view");			//@m[h
		item1.setAttribute("width","640");
		item1.setAttribute("height","480");
		root.appendChild(item1);

		//baseURL
		fileSeparatorIndex = URLString.lastIndexOf( "/" );
		String baseURLName = URLString.substring( 0, fileSeparatorIndex + 1 );
		URL baseURL = null;
		try {
			baseURL = new URL( baseURLName );
		} catch ( MalformedURLException ex ) {
			ex.printStackTrace();
			baseURL = null;
		}
		
		//Document֒ǉ
		doc.appendChild(root);
		result = new GElement( (Node)root , baseURL ,doc);
	}
	catch(Exception e){
		e.printStackTrace();
		result = null;
	}

	return result;
}
/**
  * SceneDataGSML`̃V[쐬
  * @param	sd				SceneData
  * @param	key			SceneDatãL[
  * @param baseURL	x[XURL
  * @return	ꂽGSML`̃V[
  */
public static GElement createScene(SceneData sd,String key,URL baseURL){
	GElement result = null;
	
	try{
		//DocumentIuWFNg̐
		Document doc = (Document)Class.forName( documentClassName ).newInstance();
		Element root = doc.createElement("scene");
		Element cut = doc.createElement("cut");
		
		//V[
		root.setAttribute("name",key);
				
		//wi
		int effectNum = sd.getBGEffectNumber();
		String bgFileName = sd.getBGFileName();
		
		if(bgFileName != null && bgFileName.length() != 0 ){
			Element imagelist = doc.createElement("imagelist");

			Element effect = doc.createElement("effect");
			if(sd.getBGEffectNumber() == 0)			effect.setAttribute("name","org.wffm.gassan.view.effect.Patapata_Width");
			else if(sd.getBGEffectNumber() == 1)	effect.setAttribute("name","org.wffm.gassan.view.effect.Patapata_Height");
			imagelist.appendChild(effect);
			
			cut.setAttribute("backgroundFile",bgFileName);

			Element image = doc.createElement("image");
			image.setAttribute("file", bgFileName );
			image.setAttribute("position","left");

			imagelist.appendChild(image);
			cut.appendChild(imagelist);
		}
	
		//y
		String audioFileName = sd.getAudioFileName();
		if(audioFileName != null || audioFileName.length() != 0 ){
			Element audio = doc.createElement("audio");

			audio.setAttribute("layer", "bgm" );
			audio.setAttribute("command", "loop" );
			audio.setAttribute("file", audioFileName );

			cut.appendChild(audio);
		}

		
		//l
		Element imagelist = doc.createElement("imagelist");
		
		Element effect = doc.createElement("effect");
		effect.setAttribute("name","org.wffm.gassan.view.effect.OverLay");
		imagelist.appendChild(effect);
		
		//wiǉ
		Element image = doc.createElement("image");
		image.setAttribute("file", bgFileName );
		image.setAttribute("position","left");
		imagelist.appendChild(image);
		
		for(int i = 0 ; i < 3 ;i++){
			image = doc.createElement("image");
			String charaFileName = null;
			String position = null;

			if(i == 0) {charaFileName = sd.getCHFileName_Center(); position = "center";}
			else if(i == 1) {charaFileName = sd.getCHFileName_Left(); position = "left";}
			else if(i == 2) {charaFileName = sd.getCHFileName_Right(); position = "right";}
			if(charaFileName != null && charaFileName.length() != 0 ){
				image.setAttribute("file", charaFileName );
				image.setAttribute("position", position);
				imagelist.appendChild(image);
			}
		}

		cut.appendChild(imagelist);
		
		//͏
		StringTokenizer st = new StringTokenizer(sd.getText());
		while(st.hasMoreTokens()){
			Element text = doc.createElement("text");
			text.appendChild(doc.createTextNode(st.nextToken()));

			cut.appendChild(text);
		}
		
		//IXg
		if(sd.getIsJunction()){
			Element selection = doc.createElement("selection");
			for(int i = 0;i < sd.JunctionMax;i++){
				String junctionText = sd.getJunctionText(i);
				String nextSceneKey = sd.getNextSceneFileName(i);
				if( junctionText != null && nextSceneKey != null ){
					Element alternative = doc.createElement("alternative");
					alternative.setAttribute("operation", nextSceneKey);
					alternative.appendChild(doc.createTextNode(junctionText));

					selection.appendChild(alternative);
				}
			}
			cut.appendChild(selection);
		}

		root.appendChild(cut);
		//Document֒ǉ
		doc.appendChild(root);
		
		result = new GElement( (Node)root ,baseURL,doc);
	}
	catch(Exception e){
		e.printStackTrace();
		result = null;
	}
	
	return result;
}
}
