package org.wffm.gassan.view.composer;

/*
 * ImageComposer.java - Short Description
 * Copyright (C) 2000 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.awt.Component;
import java.awt.Graphics;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.image.RGBImageFilter;
import java.awt.image.BufferedImage;
import java.util.Map;
import java.util.List;

import org.wffm.gassan.view.image.ImageCreater;
import org.wffm.gassan.view.image.ImageCreaterException;

/**
  * C[WNX
  * @version 1.0.0, 2000/12/01
  * @author Yosuke Sato
  */
public abstract class Composer extends RGBImageFilter implements ImageCreater {
	//
	//  W
	//
	//=========================================================================
	private List _source = null;
	
	//
	//  
	//
	//=========================================================================
	private Map param = null;
	private Component comp = null;

	public static final String packageName = "org.wffm.gassan.view.composer.";
/**
 * RXgN^
 */
public Composer() {
	super();
}
/**
  * ComposerpNX𐶐
  * @param	className	ComposerpNX̖O
  * @return	ꂽComposer
  */
public static Composer create(String className) throws ImageCreaterException{
	Composer ret = null;
	
	try{
		ret = (Composer)Class.forName(className).newInstance();
	}
	catch(Exception e){
		ret = null;
	}

	//pbP[W⊮@\
	if(ret == null){
		try{
			ret = (Composer)Class.forName(packageName + className).newInstance();
		}
		catch(Exception e){
			System.err.println("Can not create Composer : " + className);
			throw new ImageCreaterException();
		}
	}
	
	return ret;
}
protected BufferedImage createBufferedImage(Image image){
	BufferedImage ret = null;
	if(image != null){
		ret = new BufferedImage(image.getWidth(getComponent()),image.getHeight(getComponent()),BufferedImage.TYPE_INT_RGB);
		Graphics g = ret.createGraphics();
		g.drawImage(image,0,0,getComponent());
	}
	else{
		ret = new BufferedImage((int)getComponent().getSize().getWidth(),(int)getComponent().getSize().getHeight(),BufferedImage.TYPE_INT_RGB);
	}
	return ret;
}
/**
  * R|[lg擾
  * @return	R|[lg
  */
public Component getComponent(){
	return comp;
}
/**
  * p[^擾
  * @return	p[^
  */
public Map getParam(){
	return param;
}
/**
  * \[X擾
  * @return	\[X
  */
public List getSource(){
	return _source;
}
/**
  * R|[lgݒ
  * @param	comp	R|[lg
  */
public void setComponent(Component comp){
	this.comp = comp;
}
/**
  * p[^ݒ
  * @param	param	p[^
  */
public void setParam(Map param){
	this.param = param;
}
/**
  * \[Xݒ
  * @param	_source	\[X
  */
public void setSource(List _source){
	this._source = _source;
}
}
