/* Public Domain Sources */

package org.wffm.gassan.view.loader.bmp;

import java.awt.image.ImageConsumer;
import java.awt.image.ColorModel;
import java.awt.image.DirectColorModel;


/**
  * BMPFullColor
  * @version 1.0.0, 2000/12/01
  * @author D.Miki
  */
class BMPFullColor extends Bitmap {

  static Bitmap load(BitmapFileHeader bmpfh,BitmapInfoHeader bmpih,WordableDataInputStream is) throws Exception {
	int[] vram=new int[bmpih.getWidth()*bmpih.getHeight()];
	int skip=(bmpih.getWidth()*3%4!=0)?4-(bmpih.getWidth()*3%4):0;
	for(int j=0;j<bmpih.getHeight();++j){
	  int ofs=(bmpih.getHeight()-1-j)*bmpih.getWidth();
	  for(int i=0;i<bmpih.getWidth();++i){
		int ub = is.readUnsignedByte() << 16;
		ub |= is.readUnsignedByte() << 8;
		ub |= is.readUnsignedByte();
		vram[ofs+i] = ub;
	  }
	  is.skipBytes(skip);
	}
	return new BMPFullColor(bmpfh,bmpih,vram);
  }          

  private int[] vram;

  private BMPFullColor(BitmapFileHeader bmpfh,BitmapInfoHeader bmpih,int[] vram){
	super(bmpfh,bmpih,new DirectColorModel(32,0x0000ff,0x00ff00,0xff0000));
	this.vram=vram;
  }          

  protected void setPixelData() {
	BitmapInfoHeader bih=this.getInfoHeader();
	this.getImageConsumer().setPixels(
	  0,0,bih.getWidth(),bih.getHeight(),this.getColorModel(),this.vram,0,bih.getWidth()
	);
  }          

}