package org.wffm.gassan.view.plugin;

/*
 * DefaultEnding.java - Short Description
 * Copyright (C) 1999-2000 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.net.URL;
import java.net.MalformedURLException;
import java.io.File;
import java.applet.AudioClip;
import java.applet.Applet;
import java.awt.Color;
import java.awt.Image;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Dimension;
import java.awt.event.MouseListener;
import java.awt.image.BufferedImage;
import java.awt.font.TextLayout;
import java.awt.font.FontRenderContext;
import javax.swing.ImageIcon;
import java.util.Vector;

/**
  * GfBORvOC
  * @version 1.1.0, 2000/11/22
  * @author Yosuke Sato
  */
public class DefaultEnding extends GPlugin implements Runnable,MouseListener{

	//
	//  [Jϐ
	//
	//=========================================================================
	private Thread kick = null;
	
	private Image offImage = null;
	private Image bkImage = null;
	private AudioClip audioClip = null;
	private String[][] message = {	{"G3 PROJECT"," "," "," "},
									{"Director"," ","KOMORI Hiroshi"," "," "," "},
									{"Program"," ","Yosuke Sato"," ","Hidekazu Furukawa"," ","D.Miki"," ","KOSHIKAWA Yasunori"," ","masahiro AMANO"," "," "," "},
									{"GSML"," ","Manabu Kai"," "," "," "},
									{"Manual"," ","A.A.W. Hiroaki Kouno"," "," "," "},
									{"System Check"," ","Daichi T.GOTO"}};
	private String lastMessage = "Copyright(c) 2001 WFFM";
	private Vector lines = new Vector();
	private Line lastLine = null;
	private int fontSize1 = 0;
	private int fontSize2 = 0;

	private final String imageFileName = "resources/plugin/ending.gif";
	private final String audioFileName = "resources/plugin/ending.mid";
	private final double fontRatio1 = 21.4;	//lp
	private final double fontRatio2 = 25.6;	//^Cgp

	//\sǗCi[NX
	public class Line{
		Font font = null;
		String text = null;
		int x = 0;
		int y = 0;
		int color = 0;
	}
	/**
	  * RXgN^
	  */
	public DefaultEnding(){
		URL resourceURL = null;
		File audioFile = new java.io.File( audioFileName );
		try {
			resourceURL = audioFile.toURL();
		} catch ( MalformedURLException ex ) {
			resourceURL = null;
		}
		if(resourceURL != null)	audioClip = Applet.newAudioClip(resourceURL);
		setBackground(Color.black);
		this.addMouseListener(this);
	}
	private Image createBackImage(){
		Dimension size = getSize();
		Image buff = createImage((int)size.getWidth(),(int)size.getHeight());
		Graphics2D g2 = (Graphics2D)buff.getGraphics();
		g2.setColor(Color.black);
		g2.fillRect(0,0,(int)size.getWidth(),(int)size.getHeight());
		ImageIcon imageIcon = new ImageIcon(imageFileName);
		g2.drawImage(imageIcon.getImage(),0,0,this);
		return buff;
	}
	private void drawLine(Graphics g,Line line){
		Dimension size = getSize();
		int addColor = 255 / ((((int)size.getHeight()) / 2) / 5);
		if(line.y < (int)size.getHeight()){
			line.color = line.color + addColor;
			if(line.color > 255)	line.color = 255;
		}
		g.setColor(new Color(line.color,line.color,line.color));
		g.setFont(line.font);
		g.drawString(line.text,line.x,line.y);
		line.y = line.y - 5;
	}
public void init(){
	start();
}
	private void lineInitialize(Graphics2D g2){
		
		//Line
		Font font1 = new Font("serif", Font.BOLD,fontSize2);	//Ep
		Font font2 = new Font("serif", Font.PLAIN,fontSize1);	//lp
		Font font3 = new Font("serif", Font.BOLD,fontSize1);	//^Cgp

		FontRenderContext frc = g2.getFontRenderContext();
		
		Dimension size = getSize();
		int x = (int)((size.getWidth() / 3) + (size.getWidth() / 3));
		int y = (int)size.getHeight() + fontSize1;

		for(int i = 0;i < message.length;i++){
			for(int j = 0; j < message[i].length;j++){
				Font font = null;
				if(j == 0)	font = font1;
				else		font = font2;
				String text = message[i][j];
				TextLayout tl = new TextLayout(text,font,frc);
				int fontWidth = (int)tl.getVisibleAdvance();
				Line line = new Line();
				line.font = font;
				line.text = text;
				line.y = y;
				line.x = x - (fontWidth / 2);
				lines.addElement(line);
				y = y + font.getSize();
			}
		}

		TextLayout tl = new TextLayout(lastMessage,font3,frc);
		int fontWidth = (int)tl.getVisibleAdvance();
		lastLine = new Line();
		lastLine.font = font3;
		lastLine.text = lastMessage;
		lastLine.y = (int)size.getHeight() + fontSize1;
		lastLine.x = x - (fontWidth / 2);
	}
	public void mouseClicked(java.awt.event.MouseEvent e) {}
	public void mouseEntered(java.awt.event.MouseEvent e) {}
	public void mouseExited(java.awt.event.MouseEvent e) {}
public void mousePressed(java.awt.event.MouseEvent e) {
	stop();
	if( getStage() != null){
		getStage().reaction();
	}
}
	public void mouseReleased(java.awt.event.MouseEvent e) {}
	public void paint(Graphics g){
		if(offImage != null){
			g.drawImage(offImage,0,0,this);
		}
	}
	public void run(){
		audioClip.loop();
		lineInitialize((Graphics2D)getGraphics());
		bkImage = createBackImage();
		offImage = bkImage;
		repaint();
		Dimension size = getSize();
		Thread thisThread = Thread.currentThread();
		
		while(true){
			if(kick != thisThread){
				return;
			}
			Image buff = createImage((int)size.getWidth(),(int)size.getHeight());
			Graphics2D g2= (Graphics2D)buff.getGraphics();
			g2.drawImage(bkImage,0,0,this);
			Line last = null;
			for(int j = 0;j < lines.size();j++){
				Line line = (Line)lines.elementAt(j);
				drawLine(g2,line);
				last = line;
			}
			if(last != null && last.y < -fontSize1)	break;
			offImage = buff;
			repaint();
			timer(100);
		}
		
		while(true){
			if(kick != thisThread){
				return;
			}
			Image buff = createImage((int)size.getWidth(),(int)size.getHeight());
			Graphics2D g2= (Graphics2D)buff.getGraphics();
			g2.drawImage(bkImage,0,0,this);
			drawLine(g2,lastLine);
			if(lastLine.y < (int)(size.getHeight()/2)	)	break;
			offImage = buff;
			repaint();
			timer(100);
		}
	}
	public void setSize(int width,int height){
		super.setSize(width,height);
		//tHgTCYvZ
		fontSize1 = (int)(width / fontRatio1);
		fontSize2 = (int)(width / fontRatio2);
	}
	public void setSize(Dimension size){
		super.setSize(size);
		//tHgTCYvZ
		int width = (int)size.getWidth();
		fontSize1 = (int)(width / fontRatio1);
		fontSize2 = (int)(width / fontRatio2);
	}
/**
  * vOCJn
  */
public void start(){
	kick = new Thread(this);
	kick.start();
}
/**
 * vOC~
  */
public void stop(){
	audioClip.stop();
	if(kick != null){
		//kick.stop();
		kick = null;
	}
}
}
