package org.wffm.gassan.view.plugin;

/*
 * DefaultOpening.java - Short Description
 * Copyright (C) 1999-2000 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
import java.net.URL;
import java.net.MalformedURLException;
import java.io.File;
import java.applet.AudioClip;
import java.applet.Applet;
import java.awt.Color;
import java.awt.Image;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Dimension;
import java.awt.TexturePaint;
import java.awt.Rectangle;
import java.awt.Point;
import java.awt.GradientPaint;
import java.awt.event.MouseListener;
import java.awt.image.BufferedImage;
import java.awt.font.TextLayout;
import java.awt.font.FontRenderContext;
import java.awt.geom.Ellipse2D;
import java.awt.geom.Rectangle2D;

/**
  * I[vjORvOC
  * @version 1.1.0, 2000/11/22
  * @author Yosuke Sato
  */
public class DefaultOpening extends GPlugin implements Runnable,MouseListener{

	//
	//  [Jϐ
	//
	//=========================================================================
	private Thread kick = null;
	private Image offImage = null;
	private Image bkImage = null;
	private final String message1 = "NOW GASSAN SYSTEM CHECKING ...";	// "CAST IN THE NAME OF GOD";
	private final String message2 = "CONDITION GREEN";					//"YE NOT GUILTY";
	private int fontSize = 0;
	private Ellipse2D.Double clip = null;								//Nbv̈
	private AudioClip audioClip = null;
	private final String openingAudioFileName = "resources/plugin/opening.wav";
	private final double fontRatio = 21.4;
	/**
	  * RXgN^
	  */
	public DefaultOpening(){
		URL resourceURL = null;
		File audioFile = new java.io.File( openingAudioFileName );
		try {
			resourceURL = audioFile.toURL();
		} catch ( MalformedURLException ex ) {
			resourceURL = null;
		}
		if(resourceURL != null)	audioClip = Applet.newAudioClip(resourceURL);
		this.addMouseListener(this);
	}
	private Image createBackImage(){
		Dimension size = getSize();
		Image buff = createImage((int)size.getWidth(),(int)size.getHeight());
		Graphics2D g2 = (Graphics2D)buff.getGraphics();

		//Of[V
		g2.setPaint(new GradientPaint((int)size.getWidth(),(int)(size.getHeight()/2),Color.lightGray,(int)size.getWidth(),(int)size.getHeight(),Color.black,true));
		g2.fill(new Rectangle2D.Double(0,0,size.getWidth(),size.getHeight()));

		Point p = new Point((int)(size.getWidth()/2),(int)(size.getHeight()/2));
		int r;
		if(size.getWidth() > size.getHeight())	r = (int)(size.getHeight()/2);
		else									r = (int)(size.getWidth()/2);
		drawFrame(g2,p,r);
		
		return buff;
	}
	private void drawFrame(Graphics2D g2,Point p,int r){

		//r͔a
		int x = p.x - r;
		int y = p.y - r;
		int w = r * 2;
		int h = r * 2;

		//Nbv̈
		clip = new Ellipse2D.Double(x+30,y+30,w-60,h-60);

		//eNX`[`
		BufferedImage bi = new BufferedImage(10,10,BufferedImage.TYPE_INT_RGB);
		Graphics2D big = bi.createGraphics();
		big.setColor(Color.black);
		big.fillRect(0,0,10,10);
		big.setColor(new Color(0,64,0));
		big.drawLine(0,5,10,5);
		big.drawLine(0,10,10,10);

		Rectangle rect = new Rectangle(0,0,10,10);
		g2.setPaint(new TexturePaint(bi,rect));
		g2.fill(new Ellipse2D.Double(x,y,w,h));

		//t[`
		for(int i = 0;i<15;i++){
			g2.setColor(new Color(i*15,i*15,i*15));
			g2.drawOval(x+i,y+i,w-2*i,h-2*i);
		}
		for(int i =0;i<15;i++){
			g2.setColor(new Color((15-i)*15,(15-i)*15,(15-i)*15));
			g2.drawOval(x+15+i,y+15+i,w-30-2*i,h-30-2*i);
		}
	}
public void init(){
	start();
}
	public void mouseClicked(java.awt.event.MouseEvent e) {}
	public void mouseEntered(java.awt.event.MouseEvent e) {}
	public void mouseExited(java.awt.event.MouseEvent e) {}
public void mousePressed(java.awt.event.MouseEvent e) {
	stop();
	if( getStage() != null){
		getStage().reaction();
	}
}
	public void mouseReleased(java.awt.event.MouseEvent e) {}
	public void paint(Graphics g){
		if(offImage != null){
			g.drawImage(offImage,0,0,this);
		}
	}
	public void run(){
		Dimension size = getSize();
		bkImage = createBackImage();
		offImage = bkImage;
		repaint();
		timer(1000);
		Thread thisThread = Thread.currentThread();
		
		Image buff = createImage((int)size.getWidth(),(int)size.getHeight());
		Graphics2D g2= (Graphics2D)buff.getGraphics();
		FontRenderContext frc = g2.getFontRenderContext();
		
		Font f = new Font("serif", Font.PLAIN,fontSize);
		g2.setFont(f);
		g2.setColor(Color.white);

		TextLayout tl = new TextLayout(message1,f,frc);
		int fontWidth = (int)tl.getVisibleAdvance();
		for(int i = (int)size.getWidth();i > - fontWidth;i = i - 35){
			if(kick != thisThread){
				return;
			}
			
			g2.drawImage(bkImage,0,0,this);
			g2.setClip(clip);
			g2.drawString(message1,i,((int)(size.getHeight()/2)) + (f.getSize() / 2));

			offImage = buff;
			repaint();
			timer(70);
		}

		tl = new TextLayout(message2,f,frc);
		fontWidth = (int)tl.getVisibleAdvance();
		for(int i = (int)size.getWidth();i > ((int)size.getWidth() / 2) - (fontWidth / 2 ) ;i = i - 35){
			if(kick != thisThread){
				return;
			}
			
			g2.drawImage(bkImage,0,0,this);
			g2.setClip(clip);
			g2.drawString(message2,i,((int)(size.getHeight()/2)) + (f.getSize() / 2));

			offImage = buff;
			repaint();
			timer(70);
		}

		boolean b = true;
		int y =  ((int)size.getWidth() / 2) - (fontWidth / 2 );
		for(int i = 0; i < 7; i++){
			if(kick != thisThread){
				return;
			}
			
			g2.drawImage(bkImage,0,0,this);
			g2.setClip(clip);
			if(b){
				g2.drawString(message2,y,((int)(size.getHeight()/2)) + (f.getSize() / 2));
				if(audioClip!= null)	audioClip.play();
			}
			b = !b;
			offImage = buff;
			repaint();
			timer(600);
		}
		timer(2000);
		if(kick != thisThread){
			return;
		}
		
		if( getStage() != null){
			getStage().reaction();
		}
	}
	public void setSize(int width,int height){
		super.setSize(width,height);
		//tHgTCYvZ
		fontSize = (int)(width / fontRatio);
	}
	public void setSize(Dimension size){
		super.setSize(size);
		//tHgTCYvZ
		int width = (int)size.getWidth();
		fontSize = (int)(width / fontRatio);
	}
/**
  * vOCJn
  */
public void start(){
	kick = new Thread(this);
	kick.start();
}
/**
 * vOC~
  */
public void stop(){
	if(kick != null){
		//kick.stop();
		kick = null;
	}
}
}
