package org.wffm.gassan.view.plugin;

/*
 * MoviePlugin.java - Short Description
 * Copyright (C) 2001 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.awt.*;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;
import java.io.File;
import java.net.URL;

import javax.media.*;

import org.wffm.gassan.view.plugin.movie.MoviePanel;
import org.wffm.gassan.view.plugin.movie.MoviePlayerPanel;

/**
  * [r[ĐRvOC
  * @version 1.0.0, 2001/01/22
  * @author Yosuke Sato
  */
public class MoviePlugin extends GPlugin {
	
	//
	//  [Jϐ
	//
	//=========================================================================
	private MouseEventHandler mouseEventHandler = new MouseEventHandler();
	private MoviePanel panel = null;
	//private MoviePlayerPanel panel = null;

	public static final int defaultMovieWidth = 320;
	public static final int defaultMovieHeight = 240;
	
class MouseEventHandler implements MouseListener {
	public void mouseClicked(MouseEvent e) {
		if (e.getSource() == MoviePlugin.this){
			if(getStage() != null){
				if(panel != null){
					panel.stop();
				}
				//Iʒm
				getStage().reaction();
			}
		}
	}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {}
}
 private static MediaLocator createMediaLocator(String path){
	MediaLocator ml;
	if(path.length()==0) return null;

	if(path.indexOf(":")> 0 &&(ml=new MediaLocator(path))!=null)
	  return ml;

	if(path.startsWith(File.separator)){
	  if((ml=new MediaLocator("file:"+path))!=null)
	return ml;
	}
	else {
	  String file="file:"+System.getProperty("user.dir")+File.separator+path;
	  if((ml=new MediaLocator(file))!=null)
	return ml;
	}

	return null;
  }    
/**
  * 
  */
public void init() throws GPluginException {
	this.addMouseListener(mouseEventHandler);
	
	try{
		Object o = Class.forName("javax.media.SystemTimeBase").newInstance();
	}
	catch(Exception e){
		//JMF݂Ȃꍇ
		System.err.println("Not find JMF.");
		throw new GPluginException();
	}
	
	setBackground(Color.black);
	
	try{
		String filename = (String)getParam().get("file");
		
		MediaLocator location=createMediaLocator(filename);
		panel = new MoviePanel(location);
		panel.setGPlugin(this);
		/*
		panel = new MoviePlayerPanel();
		panel.setGPlugin(this);
		panel.init(filename);
		*/
		//setLayout(new BorderLayout());
		//add(panel,"Center");
		int width = defaultMovieWidth;
		int height = defaultMovieHeight;
		
		if(getParam().containsKey("width")){
			String s = (String)getParam().get("width");
			try{
				width = Integer.parseInt(s);
			}catch(Exception e){
				width = defaultMovieWidth;
			}
		}
		if(getParam().containsKey("height")){
			String s = (String)getParam().get("height");
			try{
				height = Integer.parseInt(s);
			}catch(Exception e){
				height = defaultMovieHeight;
			}
		}
		
		int x = (int)getSize().getWidth() / 2 - width / 2;
		int y = (int)getSize().getHeight() / 2 - height / 2;
		panel.setBounds(x,y,width,height);
		setLayout(null);
		add(panel);
							
		panel.start();
	}catch(Exception e){
		System.err.println("Can not Start MoviePlugin.");
		throw new GPluginException();
	}
}
public void paintComponent(Graphics g) {
	super.paintComponent(g);
	if(getBackImage() != null){
		g.drawImage(getBackImage(),0,0,this);
	}
}
}
