package org.wffm.gassan.view.plugin.movie;

import javax.media.*;

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;



import org.wffm.gassan.view.plugin.GPlugin;/**
  * [r[pl
  * @version 1.0.0, 2001/01/22
  * @author Yosuke Sato
  */
  
public class MoviePanel extends Panel{

	//
	//  [Jϐ
	//
	//=========================================================================
	
  	private transient Player player=null;
	private Component progressBar=null;
	private boolean playLoop=false;

	private transient Object waitSync=new Object();

/**
  * RXgN^
  * @param url 摜t@CuĂURL
  */
public MoviePanel(URL url){
	player=getPlayer(url);
	initialize();
}      
/**
  * RXgN^
  */
public MoviePanel(MediaLocator location){
	try{ 
		player=Manager.createPlayer(location);
		initialize();
	}
	catch(Exception e){
		fatalError(e.getMessage());
	}
}  
/**
  * RXgN^
  * @param player 摜\NX
  */
public MoviePanel(Player player){
	this.player=player;
	initialize();
}  
private void initialize(){
	if(player==null){
		throw new NullPointerException("no player");
	}
	setLayout(new BorderLayout());
	player.addControllerListener(adapter);
		
	player.prefetch();
	synchronized(waitSync){
		while(player.getState()!=Player.Prefetched){
			try{
				waitSync.wait(1000);
			}catch(InterruptedException e){ }
		}
	}
}
 
/**
 * 摜JԂĐ邩ǂ
 */
public boolean isLoop(){
	return playLoop;
}  
/**
  * 摜JԂĐ邩ǂݒ
  * @param flag JԂĐȂtrueAłȂȂfalse
  */
public void setLoop(boolean flag){
	playLoop=flag;
}  
/**
  * 摜̍Đn߂鎞ɌĂяo
  */
public void start(){
	if(player!=null){
		player.start();
	}
} 
/**
  * 摜̍ĐIɌĂяo\bh
  */
public void close(){
	player.close();
}  
/**
  * 摜̍ĐIÃCxg҂Ă
  */
public void stop(){
	if(player!=null){
		player.stop(); player.deallocate();
	}
}  
private void fatalError(String msg){
	System.err.println(msg);
	throw new Error(msg);
}      
private static Frame getParentFrame(Component comp){
	Frame parent=null;
	while((comp!=null) && (parent==null)){
		if(comp instanceof Frame){
			parent=(Frame)comp;
		}
		else{
			comp=comp.getParent();
		}
	}
	return parent;
}  
private static MediaLocator createMediaLocator(String path){
	MediaLocator ml;
	if(path.length() == 0){
		return null;
	}
	
	if(path.indexOf(":")> 0 &&(ml=new MediaLocator(path))!=null){
		return ml;
	}
	
	if(path.startsWith(File.separator)){
		if((ml=new MediaLocator("file:"+path))!=null){
			return ml;
		}
		else {
			String file="file:"+System.getProperty("user.dir")+File.separator+path;
			if((ml=new MediaLocator(file))!=null){
				return ml;
			}
		}
	}
	return null;
}  
private Player getPlayer(URL url){
	Player p=null;
	String error=null;
	try{
		if((p=Manager.createPlayer(url))==null){
			fatalError("Could not create palyer for "+url);
		}
	}
	catch(NoPlayerException e){
		fatalError("MoviePanel: no player exception creating player for "+url);
	}
	catch(NullPointerException ee){
		fatalError("MoviePanel: null pointer exception creating player for "+url);
	}
	catch(IOException e){
		fatalError("MoviePanel: I/O exception creating player for "+url);
	}
	return p;
}  
public static void main(String[] args){
	if(args.length==0){
		System.err.println("Usage: "+MoviePanel.class.getName()+" <file|url>");
		System.exit(1);
	}
	MediaLocator location=createMediaLocator(args[0]);
	Frame f=new Frame();
	f.setLayout(new BorderLayout());
	f.add(new MoviePanel(location),BorderLayout.CENTER);
	f.pack();
	f.setVisible(true);
}  
	//
	//  ֘A
	//
	//=========================================================================
	private GPlugin _plugin = null;	private MoviePanelAdapter adapter = new MoviePanelAdapter();class MoviePanelAdapter extends ControllerAdapter{
	public void realizeComplete(RealizeCompleteEvent e){
		Component visual = null,controller = null;
		visual = player.getVisualComponent();
		if((controller=player.getControlPanelComponent()) == null){
			throw new NullPointerException("no component got");
		}
		if(visual!=null){
			add(visual,BorderLayout.CENTER);
		}
		add(controller,BorderLayout.SOUTH);
		validate();
		player.stop();
		synchronized(waitSync){
	 		waitSync.notifyAll();
		}
		/*
		Frame f = getParentFrame(MoviePanel.this);
		if(f != null){
			f.pack();
			f.setVisible(true);
		}
		*/
	}
	
	public void endOfMedia(EndOfMediaEvent e){
		if(playLoop){
			player.setMediaTime(new Time(0));
			player.start();
		}
		else{
			//Iʒm
			if(getGPlugin() != null && getGPlugin().getStage() != null){
				getGPlugin().getStage().reaction();
			}
		}
	}
	
	public void controllerError(ControllerErrorEvent e){
		fatalError(e.getMessage());
	}
	
	public void cachingControl(CachingControlEvent e){
		CachingControl cc = e.getCachingControl();
		long cc_progress = e.getContentProgress();
		long cc_length = cc.getContentLength();
		if(progressBar == null){
				if((progressBar = cc.getProgressBarComponent())!=null){
				add(progressBar,"North");
				validate();
			}
		}
		if(progressBar!=null){
			if(cc_progress==cc_length){
				remove(progressBar);
				progressBar=null;
				validate();
			}
		}
	}
}/**
  * RvOC擾
  * @return	RvOC
  */
public GPlugin getGPlugin(){
	return _plugin;
}/**
  * RvOCݒ
  * @param	_plugin	RvOC
  */
public void setGPlugin(GPlugin _plugin){
	this._plugin = _plugin;
}}