package org.wffm.gsmlviewer;

/*
 * AudioPlayer.java - Short Description
 * Copyright (C) 2000 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.net.URL;

/**
  * ytNX
  * @version 1.0.1, 2000/11/22
  * @author Yosuke Sato
  */
public abstract class AudioPlayer {
	//
	//@
	//
	//=========================================================================
	private URL source = null;
	private boolean state = true;		//t Đ\Ȃture,ȊOfalse
	private boolean state_loop = false;	//[v [vĐȂture,ȊOfalse
/**
  * NA
  */
public abstract void clear();
/**
  * yĐNX
  * @return	yĐNX
  */
public static AudioPlayer create(){
	AudioPlayer ret = null;

	try{
		Object o = Class.forName("javax.media.SystemTimeBase").newInstance();
		ret = (AudioPlayer)Class.forName("org.wffm.gsmlviewer.JMFAudioPlayer").newInstance();
	}
	catch(ClassNotFoundException e){
		//JMF݂Ȃꍇ
		System.err.println("Not find JMF.");
		ret = new AppletAudioPlayer();
		
	}
	catch(Exception e){
		System.err.println("Audio Error...");
		ret = null;
	}

	return ret;
}
/**
  * [vԂ擾
  * [vt̏ꍇtrue,ȊOfalse
  * @return	[v
  */
public boolean getLoop(){
	return state_loop;
}
/**
  * \[X擾
  * @return	\[X
  */
public URL getSource(){
	return source;
}
/**
  * tԂݒ
  * Đ\Ȃture,ȊOfalse
  * @return	t
  */
public boolean getState(){
	return state;
}
/**
  * \[Xr
  * \[XȂture,ȊOfalse
  * @return	r
  */
public boolean isSource(URL url){
	boolean ret = false;

	if(source != null && url != null){
		if(source.toString().equals( url.toString() )){
			ret = true;
		}
	}

	return ret;
}
public static void main(String[] argv) {
	try{
		java.io.File file = new java.io.File(argv[0]);
		AudioPlayer audioPlayer = AudioPlayer.create();
		audioPlayer.setAudio(file.toURL());
		audioPlayer.setState(true);
		audioPlayer.play();
	}
	catch( ArrayIndexOutOfBoundsException e){
		System.err.println("Usage: java AudioPlayer filename");
	}
	catch( java.io.IOException e ){
		System.err.println(argv[0] + "not Found");
	}
	catch( Exception e ){
		System.err.println(e);
	}	
}
/**
  * tJn
  */
public abstract void play();
/**
  * yݒ
  * @param	source	\[XURL
  */
public abstract void setAudio(URL source);
/**
  * [vԂݒ
  * [vtȂture,ȊOfalse
  * @param	state_loop	[v
  */
public void setLoop(boolean state_loop){
	this.state_loop = state_loop;
}
protected void setSource(URL source){
	this.source = source;
}
/**
  * tԂݒ
  * Đ\Ȃture,ȊOfalse
  * @param	audioState	t
  */
public void setState(boolean state){
	this.state = state;
	if(!state){
		stop();
	}
}
/**
  * t~
  */
public abstract void stop();
}
