package org.wffm.gsmlviewer;

/*
 * JMFAudioPlayer.java - Short Description
 * Copyright (C) 2000 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.io.IOException;
import java.net.URL;
import java.net.MalformedURLException;

import javax.media.Manager;
import javax.media.Player;
import javax.media.ControllerListener;
import javax.media.ControllerEvent;
import javax.media.EndOfMediaEvent;
import javax.media.Time;
import javax.media.NoPlayerException;

/**
  * JMFytNX
  * @version 1.0.1, 2000/11/22
  * @author Yosuke Sato
  */
public class JMFAudioPlayer extends AudioPlayer implements ControllerListener{
	//
	//  [Jϐ
	//
	//=========================================================================
	private Player player = null;
/**
 * RXgN^
 */
public JMFAudioPlayer(){
}
/**
  * NA
  */
public void clear(){
	stop();
	setLoop(false);
	player = null;
}
public synchronized void controllerUpdate(ControllerEvent event) {
	if(event instanceof EndOfMediaEvent) {
		if(getState() && getLoop()){
			player.setMediaTime(new Time(0));
			player.start();
		}
	}
}
/**
  * JMFPlayer𐶐
  * @param	source		\[XURL
  * @return	ꂽv[[
  * JMF߂̈ResourceFactoryɉĂȂ
  */
private static Player createPlayer(URL source){
	Player ret = null;

	if(source != null){
		try{
			ret = Manager.createPlayer(source);
		}
		catch( IOException e ){
			System.err.println(source.toString() + "not Found");
			ret = null;
		}
		catch( NoPlayerException e){
			System.err.println(source.toString() + " : No support format.");
			ret = null;
		}
		catch( Exception e){
			ret = null;
		}
	}
	
	return ret;
}
/**
  * tJn
  */
public void play(){
	if(getState()){
		if(player != null){
			player.start();
		}
	}
}
/**
  * yݒ
  * @param	source		\[XURL
  */
public void setAudio(URL source){
	setSource(source);
	
	stop();
	player = null;
	
	if(source != null){
		player = createPlayer(source);
		if(player != null){
			player.addControllerListener(this);
		}
	}
}
/**
  * t~
  */
public void stop(){
	if(player != null){
		player.stop();
		player.deallocate();
	}
}
}
