package org.wffm.gsmlviewer;

/*
 * ResourceFactory.java - Short Description
 * Copyright (C) 2000 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
 
import java.awt.Image;
import java.net.URL;
import java.net.MalformedURLException;

import javax.swing.ImageIcon;

import org.wffm.gassan.view.loader.ImageLoader;

/**
  * GSML\[Xpc[NX
  * @version 1.0.1, 2000/11/23
  * @author Yosuke Sato
  */
public class ResourceFactory {
/**
  * C[W𐶐
  * @param	source		URL
  * @return	ꂽC[W
  */
public static Image createImage(URL source){
	return createImage(source,"org.wffm.gassan.view.loader.DefaultImageLoader");
}
/**
  * C[W𐶐
  * @param	source		URL
  * @param	loader		C[W[_̃NX
  * @return	ꂽC[W
  */
public static Image createImage(URL source,String loaderName){
	Image ret = null;

	try{
		if(source != null && loaderName != null){
			ImageLoader loader = ImageLoader.create(loaderName);
			
			if(loader != null){
				loader.setSrc(source);
				ret = loader.getImage();
			}
		}
	}catch(Exception e){
		System.err.println("Can not create image : " + source.toString());
		ret = null;
	}
	
	return ret;
}
/**
  * ResourceURL𐶐
  * @param	baseURL		x[XURL
  * @param	fileName	C[Wt@C
  * @return	ꂽURL
  */
public static URL createURL(URL baseURL,String fileName){
	URL ret = null;
	
	String uriString = fileName;
	if(baseURL != null){
		uriString = baseURL.toString() + fileName;
	}
	
	try{
		ret = new URL(uriString);
	}catch(MalformedURLException e){
		ret = null;
	}
	
	return ret;
}
}
