package org.wffm.gsmlviewer.factory;

/*
 * DialogTextFactory.java - Short Description
 * Copyright (C) 2000 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.awt.Dimension;
import java.awt.Point;
import java.awt.Color;

import javax.swing.JPanel;

import org.wffm.gsmlviewer.GEMLUtility;

import org.wffm.gsmlviewer.pane.ImagePane;
import org.wffm.gsmlviewer.pane.TextPane;
import org.wffm.gsmlviewer.filter.ImagePaneFilter;
import org.wffm.gsmlviewer.filter.DialogTextFilter;

import org.wffm.gassan.model.scenario.GElement;
import org.wffm.gassan.model.scenario.GElementList;

/**
  * _CAO^CvView𐶐NX
  * @version 1.0.1, 2000/11/22
  * @author Yosuke Sato
  */
public class DialogTextFactory extends ViewFactory {
	private final int tabSize = 20;			//^ũTCY
	private final int line = 5;				//s
	private final int emptyline = 1;		//󔒍s
	
	public static final double fontRatio = 30;	//tHg̔䗦
private int getFontSize(Dimension viewSize){
	//PrefferedSizẽtHgTCYvZ
	int width = (int)viewSize.getWidth();
	return (int)(width / fontRatio);
}
/**
  * eLXgGA̕\ʒu擾
  * @return	eLXgGA̕\ʒu
  */
private Point getTextAreaPosition(Dimension viewSize){
	int x = tabSize;
	int y = (int)viewSize.getHeight() - ((getFontSize(viewSize)+5) * (line + emptyline)) - 5;//5͍s
	return new Point(x,y);
}
/**
  * eLXgGÃTCY擾
  * @return	eLXgGÃTCY
  */
private Dimension getTextAreaSize(Dimension viewSize){
	int width = (int)viewSize.getWidth() - (tabSize * 2);
	int height = ((getFontSize(viewSize)+5) * line) + 5;	//5͍s
	return new Dimension(width,height);
}
/**
  * pl
  */
public void init_pane(){
	Dimension viewSize = getSize(getEnv());

	Point textPosition = getTextAreaPosition(viewSize);
	Dimension textSize = getTextAreaSize(viewSize);

	getContentPane().setSize(viewSize);
	
	//TextPane&
	getTextPane().init(textSize,getFontSize(viewSize));

	//ImagePane&
	getImagePane().init(viewSize);

	//ImagePaneFilter
	ImagePaneFilter filter = new DialogTextFilter();
	filter.setImagePane(getImagePane());
	filter.setPosition(textPosition);
	filter.setSize(textSize);

	getImagePane().setFilter(filter);

	//w\̎
	getContentPane().setBackground(Color.black);
	getContentPane().setLayout(null);
	getContentPane().add(getImagePane());
	getImagePane().setLayout(null);
	getImagePane().add(getTextPane());
	getTextPane().setBounds((int)textPosition.x,(int)textPosition.y,(int)textSize.getWidth(),(int)textSize.getHeight());
}
}
