package org.wffm.gsmlviewer.factory;

/*
 * FullTextFactory.java - Short Description
 * Copyright (C) 2000 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.awt.Dimension;
import java.awt.Point;
import java.awt.Color;

import javax.swing.JPanel;

import org.wffm.gsmlviewer.GEMLUtility;

import org.wffm.gsmlviewer.pane.ImagePane;
import org.wffm.gsmlviewer.pane.TextPane;
import org.wffm.gsmlviewer.filter.ImagePaneFilter;
import org.wffm.gsmlviewer.filter.FullTextFilter;

import org.wffm.gassan.model.scenario.GElement;
import org.wffm.gassan.model.scenario.GElementList;

/**
  * SʃeLXg^CvView𐶐NX
  * @version 1.0.1, 2000/11/22
  * @author Yosuke Sato
  */
public class FullTextFactory extends ViewFactory {
	public static final double fontRatio = 25.6;		//tHg̔䗦
private int getFontSize(Dimension viewSize){
	//PrefferedSizẽtHgTCYvZ
	int width = (int)viewSize.getWidth();
	return (int)(width / fontRatio);
}
/**
  * pl
  */
protected void init_pane(){
	Dimension viewSize = getSize(getEnv());

	Point textPosition = new Point(0,0);
	
	getContentPane().setSize(viewSize);
	
	//TextPane&
	getTextPane().init(viewSize,getFontSize(viewSize));

	//ImagePane&
	getImagePane().init(viewSize);

	//ImagePaneFilter
	ImagePaneFilter filter = new FullTextFilter();
	filter.setImagePane(getImagePane());
	filter.setPosition(textPosition);
	filter.setSize(viewSize);

	getImagePane().setFilter(filter);

	//w\̎
	getContentPane().setBackground(Color.black);
	getContentPane().setLayout(null);
	getContentPane().add(getImagePane());
	getContentPane().setLayout(null);
	getImagePane().add(getTextPane());
	getTextPane().setBounds((int)textPosition.x,(int)textPosition.y,(int)viewSize.getWidth(),(int)viewSize.getHeight());
}
}
