package org.wffm.gsmlviewer.filter;

/*
 * DialogTextFilter.java - Short Description
 * Copyright (C) 2000 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

//import java.awt.*;
import java.awt.Image;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Color;
import java.awt.AlphaComposite;
import java.awt.image.BufferedImage;

/**
  * _CAOeLXgptB^[NX
  * @version 1.0.0, 2000/12/26
  * @author Yosuke Sato
  */
public class DialogTextFilter extends ImagePaneFilter {
	//
	//  [Jϐ
	//
	//=========================================================================
	Image cacheImage = null;
/**
 * DialogTextFilter RXgN^[ERgB
 */
public DialogTextFilter() {
	super();
}
private BufferedImage createFrameImage(Dimension size){
	BufferedImage ret = new BufferedImage((int)size.getWidth(),(int)size.getHeight(),BufferedImage.TYPE_INT_RGB);
	Graphics g = ret.createGraphics();
	g.setColor(Color.blue);
	g.fillRect(0,0,(int)size.getWidth(),(int)size.getHeight());
	return ret;
}
private void drawFrame(Graphics2D g2,Point p,Dimension size){
	float trans=0.5f;
	AlphaComposite ac = AlphaComposite.getInstance(AlphaComposite.SRC_OVER,trans);
	g2.setComposite(ac);
	g2.drawImage(createFrameImage(size),p.x,p.y,getImagePane());
}
/**
 * filter_in \bhERgB
 */
protected void filter_in() {
	cacheImage = getImagePane().getDrawImage();
	BufferedImage buff = createBufferedImage(cacheImage);
	Graphics2D g2 = buff.createGraphics();
	drawFrame(g2,getPosition(),getSize());
	getImagePane().setDrawImage(buff);
}
/**
 * filter_out \bhERgB
 */
protected void filter_out() {
	getImagePane().setDrawImage(cacheImage);
}
}
