package org.wffm.gsmlviewer.filter;

/*
 * ImagePaneFilter.java - Short Description
 * Copyright (C) 2000 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.awt.Dimension;
import java.awt.Point;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.awt.Graphics;

import org.wffm.gsmlviewer.pane.ImagePane;

/**
  * ImagePaneptB^[NX
  * @version 1.0.0, 2000/12/26
  * @author Yosuke Sato
  */
public abstract class ImagePaneFilter {
	//
	//  ֘A
	//
	//=========================================================================
	private ImagePane _ImagePane = null;

	//
	//  
	//
	//=========================================================================
	private Dimension size = new Dimension(0,0);
	private Point position = new Point(0,0);
	private boolean state = false;					//tB^[ tB^[|Ăꍇtrue,|ĂȂꍇfalse
/**
 * RXgN^
 */
public ImagePaneFilter() {
	super();
}
protected BufferedImage createBufferedImage(Image image){
	BufferedImage ret = null;
	if(image != null){
		ret = new BufferedImage(image.getWidth(_ImagePane),image.getHeight(_ImagePane),BufferedImage.TYPE_INT_RGB);
		Graphics g = ret.createGraphics();
		g.drawImage(image,0,0,_ImagePane);
	}
	else{
		ret = new BufferedImage((int)_ImagePane.getDefaultSize().getWidth(),(int)_ImagePane.getDefaultSize().getHeight(),BufferedImage.TYPE_INT_RGB);
	}
	return ret;
}
protected abstract void filter_in();
protected abstract void filter_out();
/**
  * tB^[}
  */
public void filterIN(){
	if(!state){
		state = true;
		filter_in();
	}
}
/**
  * tB^[
  */
public void filterOUT(){
	if(state){
		state = false;
		filter_out();
	}
}
/**
  * ImagePane擾
  * @return	ImagePane
  */
public ImagePane getImagePane(){
	return _ImagePane;
}
/**
  * ʒu擾
  * @return	ImagePane
  */
public Point getPosition(){
	return position;
}
/**
  * TCY擾
  * @return	TCY
  */
public Dimension getSize(){
	return size;
}
/**
  * Ԃ擾
  * @return	(tB^[ tB^[|Ăꍇtrue,|ĂȂꍇfalse)
  */
public boolean getState(){
	return state;
}
/**
  * ImagePaneݒ
  * @param	_ImagePane	ImagePane
  */
public void setImagePane(ImagePane _ImagePane){
	this._ImagePane = _ImagePane;
}
/**
  * ʒuݒ
  * @param	_position	ʒu
  */
public void setPosition(Point position){
	this.position = position;
}
/**
  * TCYݒ
  * @param	size	TCY
  */
public void setSize(Dimension size){
	this.size = size;
}
/**
  * Ԃݒ
  * @param	state	(tB^[ tB^[|Ăꍇtrue,|ĂȂꍇfalse)
  */
public void setState(boolean state){
	this.state = state;
}
}
