package org.wffm.gsmlviewer.pane;

/*
 * TextLabel.java - Short Description
 * Copyright (C) 1999-2000 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.awt.Graphics;

import java.awt.Color;
import java.awt.Font;
import java.awt.font.FontRenderContext;
import java.awt.font.TextLayout;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;

import javax.swing.JComponent;

/**
  * et`NX
  * @version 1.1.2, 2000/12/26
  * @author Yosuke Sato
  */

public class TextLabel extends JComponent{
	
	//
	//  [Jϐ
	//
	//=========================================================================
	private int fontSize = 0;
	private boolean focus_painted = false;	//tH[JX̂Ƃɔ]\邩
	private String text = " ";				//\eLXg

	private boolean isMouseEntered = false;
	protected transient ActionListener aActionListener = null;

class MouseEventHandler implements MouseListener {

public void mouseClicked(MouseEvent e) {}

public void mouseEntered(MouseEvent e) {
	if(focus_painted){
		if ((e.getSource() == TextLabel.this) ) {
			isMouseEntered = true;
			repaint();
		}
	}
}

public void mouseExited(MouseEvent e) {
	if(focus_painted){
		if ((e.getSource() == TextLabel.this) ) {
			isMouseEntered = false;
			repaint();
		}
	}
}

public void mousePressed(MouseEvent e) {
	if ((e.getSource() == TextLabel.this) ) {
		fireActionPerformed(new ActionEvent(TextLabel.this,0,null));
	}
}

public void mouseReleased(MouseEvent e) {}
}

/**
 * RXgN^
 */
public TextLabel() {
	super();
	init();
}
public void addActionListener(ActionListener newListener) {
	aActionListener = java.awt.AWTEventMulticaster.add(aActionListener, newListener);
}
protected void fireActionPerformed(ActionEvent e) {
	if (aActionListener == null) {
		return;
	};
	aActionListener.actionPerformed(e);
}
/**
  * tH[JX̐U镑擾
  * @return	tH[JX݂Ƃɔ]\ꍇtrue,ȊOfalse
  */
public boolean getFocusPainted(){
	return focus_painted;
}
/**
  * tHg̃TCY擾
  * @return	tHgTCY
  */
public int getFontSize(){
	return fontSize;
}
/**
  * eLXg擾
  * @return	eLXg
  */
public String getText(){
	return text;
}
private void init() {
	this.addMouseListener(new MouseEventHandler());
	this.setDoubleBuffered(true);
}
public void paintComponent(Graphics g) {

	super.paintComponent(g);

	Font f = new Font("sansserif",Font.BOLD,fontSize);

	g.setFont(f);
	
	//e
	g.setColor(Color.black);
	g.drawString(text,4,fontSize + 3);

	if(focus_painted){
		if(isMouseEntered)	g.setColor(Color.white);
		else				g.setColor(Color.gray);
	}
	else					g.setColor(Color.white);
	g.drawString(text,3,fontSize);
	
}
public void removeActionListener(ActionListener newListener) {
	aActionListener = java.awt.AWTEventMulticaster.remove(aActionListener, newListener);
	return;
}
/**
  * tH[JX̐U镑ݒ
  * @param	focus_painted	tH[JX݂Ƃɔ]\ꍇtrue,ȊOfalse
  */
public void setFocusPainted(boolean focus_painted){
	this.focus_painted = focus_painted;
}
/**
  * tHg̃TCYݒ
  * @param	fontSize	tHgTCY
  */
public void setFontSize(int fontSize){
	this.fontSize = fontSize;
	repaint();
}
/**
  * eLXgݒ
  * @param	text	\eLXg
  */
public void setText(String text) {
	this.text = text;
	repaint();
}
}
